#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>

#define MAXZEILE 70
#define FAKTOR	0.025
#define PUFLEN	20

unsigned char puffer[PUFLEN], *ptr;
int c;
float z;

void hilfe(void);

int main(int argc, char *argv[])
{   FILE *infile, *outfile;
	float x_offs, y_offs;
	unsigned int i, zustand;
	unsigned char ausgabedateiname[13], eingabedateiname[9];

	clrscr();

	if(argc==1)
		hilfe();

	x_offs=atof(argv[1]);
	y_offs=atof(argv[2]);
	if(strlen(argv[3])==0)
	{	puts("namen der eingabedatei fehlt");
		puts("programm beendet");
        return(0);}
	strncpy(eingabedateiname, argv[3], 8);
	strcpy(ausgabedateiname, eingabedateiname);
	strcat(eingabedateiname,".plt");
	strcat(ausgabedateiname,".asm");

	if((infile=fopen(eingabedateiname, "r"))==NULL)
	{	printf("eingabedatei \"%s\" existiert nicht\n", eingabedateiname);
		puts("programm beendet");
		return(0);}
	outfile=fopen(ausgabedateiname, "w+t");

	i=0;
	zustand=0;
    ptr=puffer;
	memset(puffer, 0, PUFLEN);
    fprintf(outfile,"%s","\n db ");

	while((c=fgetc(infile))!=EOF)
	{	switch(zustand)
		{	case 0:
				if(c=='P')
					zustand=1;
				break;
			case 1:
				if(c=='A')
					zustand=2;
				else
					zustand=0;
				break;
			case 2:
				if(c==',')
				{	zustand=3;
					z=atof(puffer);
					i+=4;
					if(i<=70)
						fprintf(outfile,"%03d,", (unsigned)(x_offs+(z*FAKTOR)));
					else
					{	fprintf(outfile,"%03d", (unsigned)(x_offs+(z*FAKTOR)));
						i=0;
                        fprintf(outfile,"%s","\n db ");}
					printf("*");
                    ptr=puffer;
					memset(puffer, 0, PUFLEN);}
				else
					*ptr++=c;
				break;
			case 3:
				if(c==';')
				{	zustand=4;
					z=atof(puffer);
					i+=4;
					if(i<=70)
						fprintf(outfile,"%03d,", (unsigned)((y_offs-(z*FAKTOR))));
					else
					{	fprintf(outfile,"%03d", (unsigned)((y_offs-(z*FAKTOR))));
						fprintf(outfile,"%s","\n db ");
						i=0;}
					printf("*");
                    ptr=puffer;
					memset(puffer, 0, PUFLEN);}
				else
					*ptr++=c;
				break;
			case 4:
				if(c=='P')
					zustand=5;
				break;
			case 5:
				if(c=='A')
					zustand=2;
				if(c=='D')
					zustand=0;
				if(c=='U')
				{	zustand=0;
					i+=4;
					printf("*");
					if(i<=70)
						fprintf(outfile,"%03d,",0);
					else
					{	fprintf(outfile,"%03d",0);
						fprintf(outfile,"%s","\n db ");
						i=0;}}
				break;
			default:
				zustand=0;
				ptr=puffer;
				memset(puffer, 0, PUFLEN);}}

	fclose(infile);
	fclose(outfile);
	puts("\nkonvertierung beendet");
	return(0);
}

void hilfe(void)
{
	puts("aufruf:");
	puts("conv	xxx yyy eingabedatei\n");
	puts("xxx: 			(positiver)x-offset");
	puts("yyy: 			(positiver)y-offset");
	puts("eingabedatei: plotterdatei im hpgl-format, dh. plt-erweiterung");
    puts("es wird eine gleichnamige ausgabedatei mit der erweiterung .asm erzeugt");
}